#ifndef HASH_H
#define HASH_H

union element {
      unsigned n;
      char *s;
      void *p;
};

#define hnew(s) ((union element *)calloc(s,sizeof(union element)))
#define hdispose(t) free(t)
int hashes;
int hlookup(union element *,int,union element,int (*)(union element,int),int (*)(union element,union element));

#define rehash(k,p,s) (((k)*((p) + 1)) % (s))
int  hash(union element,int);

#endif
